#!/usr/bin/python
import os,sys,re,string

def pipe(command):
    fh = os.popen(command, 'r')
    result = fh.read()
    fh.close()
    return result

def readfile(filename):
    try:
	fh = open(filename, 'r')
	result = fh.read()
	fh.close()	
	return result
    except IOError:
	return ""

def exist(filename):
    try:
	dummy = os.stat(filename)
	return 1
    except os.error:
	return 0

def handle_font(name):
    if name[-4:] != ".ttf":
	print name + " is not a TTF font"
	return
    elif not exist(name):
	print "file " + name + " doesn't exist"
	return
    
    basename = "h" + string.split(name[:-4],"/")[-1]
    afm = pipe("ttf2afm "+name)
    if string.find(afm, "kaffinal") != -1:
	encoding = "winheb.enc"
    elif string.find(afm, "alef") != -1:
	encoding = "winheb2.enc"
    else:
	print name + " is not a Hebrew font"
	return
    print "Using encoding file " + encoding

    match = re.search("FontName (.*)",afm)
    if match != None:
	fontname = match.group(1)
    else:
	fontname = string.capitalize(basename)
    print "Font name is " + fontname

    cmd = "ttf2tfm %s -O -N -T %s -v tmp.vpl %s.tfm" % (name, encoding, basename)
    print "Running " + cmd
    dummy = pipe(cmd)

    fontline = "%s %s <%s <%s" % (basename, fontname, encoding, name)
    if string.find(readfile("hebrew.map"), fontline) == -1:
	print "Adding font info to hebrew.map"
	fh = open("hebrew.map", 'a')
	fh.write(fontline+"\n")
	fh.close()

    print "Changing width for nikud chars"
    fh = open("tmp.vpl", 'r')
    lines = fh.readlines()
    fh.close
    fh = open("tmp.vpl", 'w')
    n = -1
    for line in lines:
	match = re.search("CHARACTER O (\d+)", line)
	if match != None:
	    n = string.atoi(match.group(1), 8)
	if n >= 192 and n <= 210 and n not in [202, 206, 207, 208]:
	    line = re.sub("CHARWD R \d+\.?\d*","CHARWD R 0", line)
	fh.write(line)
    fh.close()

    cmd = "vptovf tmp.vpl tmp.vfm %s.tfm" % basename
    print "Running " + cmd
    os.system(cmd)
    files = ["tmp.vpl", "tmp.vfm", "%s.afm" % basename]
    print "Deleting " + string.join(files)
    for file in files:
	try:
	    os.remove(file)
	except os.error:
	    pass
if len(sys.argv) < 2:
       print "Usage: ttf.py font(s)"
       sys.exit(0)

for name in sys.argv[1:]:
    handle_font(name)
